Resolvable (Apache FOP 2.7 API)
Date: 2022-01-12

org.apache.fop.area

## Interface Resolvable

- All Known Implementing Classes:
    BookmarkData, DestinationData, LinkResolver, PageViewport, UnresolvedPageNumber

      public interface Resolvable

  Resolvable Interface. Classes that implement this interface contain idrefs (see Section 5.11 of spec for definition of <idref> datatype) that are resolved when their target IDs are added to the area tree.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String[]` | `getIDRefs()` Get the array of idrefs of this resolvable object.
    `boolean` | `isResolved()` Check if this area has been resolved.
    `void` | `resolveIDRef(java.lang.String id, java.util.List<PageViewport> pages)` This method allows the Resolvable object to resolve one of its unresolved idrefs with the actual set of PageViewports containing the target ID.

- - ### Method Detail

    - #### isResolved

          boolean isResolved()

      Check if this area has been resolved.
      Returns:
        true once this area is resolved

    - #### getIDRefs

          java.lang.String[] getIDRefs()

      Get the array of idrefs of this resolvable object. If this object contains child resolvables that are resolved through this then it should return the idref's of the child also.
      Returns:
        the id references for resolving this object

    - #### resolveIDRef

          void resolveIDRef(java.lang.String id,
                            java.util.List<PageViewport> pages)

      This method allows the Resolvable object to resolve one of its unresolved idrefs with the actual set of PageViewports containing the target ID. The Resolvable object initially identifies to the AreaTreeHandler which idrefs it needs resolved. After the idrefs are resolved, the ATH calls this method to allow the Resolvable object to update itself with the PageViewport information.
      Parameters:
        `id` - an ID matching one of the Resolvable object's unresolved idref's.
        `pages` - the list of PageViewports with the given ID

Copyright 1999-2022 The Apache Software Foundation. All Rights Reserved.